<?php
/*
 * This top level script that runs DB migration process.
 * Example of cmmand line (current working directory is root of sources e.g. /usr/local/sso/):
 *      sw-engine process/DBMigrate.php /etc/sso/sso_config.ini
 *
 * // Lather-rinse-repeat snippets:
 * // rm /var/lib/sso/sso.db; sqlite3 /var/lib/sso/sso.db < /usr/share/sso/db-schema-1.sql
 * // less /var/log/sso/sso.log
 */
require_once('path.php');
require_once('base/main_handlers.php');
require_once('lib/util.php');

// TODO (db, test) Test this code.
if ($_SERVER['argc'] > 0) { // If running from command line
    $config_file = $_SERVER['argv'][1];
    try {
        $configuration = lib_Config::get($config_file);
        configure_error_handling();
        lib_Config::getLog()->info("[begin] DB migrate.");
        $processor = new db_versioning_SchemaUtil(new lib_DefaultFileSystem());
        $processor->update($configuration->db_file);
        lib_Config::getLog()->info("[end] DB migrate." );
    } catch (Exception $e) {
        lib_Config::getLog()->error(
            "[end] DB schema update: exception caught at top level {$e->getMessage()}" );
        print "DB update failed ({$e->getMessage()}). See log file for detailed output.\n";
        die(1);
    }
}